Program XSL;
{*---------------------------------------------------------------------*}
{* XSL                                                                 *}
{* XSL Conversion Filter                                               *}
{*                                                                     *}
{*         Copyright (c) 2000 LU7DID Only for radioamateur uses        *}
(*     Excerpts from this code must be properly credited whenever used *)
(*                                                                     *)
(*                        Free for radioamateur uses                   *)
(*                      Commercial usage is prohibited                 *)
(*                                                                     *)
{*---------------------------------------------------------------------*}
{$R-}
{$APPTYPE CONSOLE}
{$H+}
{$M 512000,7000000}

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ScktComp, ReqLib32 , INIFiles, Menus, ExtCtrls, Gauges, Spin,
  ShellAPI, HexStr, ComCtrls,Log,WinTypes,MSXML2_TLB,ActiveX,ComObj;


(*-->> Constants <<---------------------------------------------------------*)
(* Main AIML Object                                                         *)
(*--------------------------------------------------------------------------*)
  Const
                                            {*------------------------------*}
                                            {*  Program Related Constants   *}
                                            {*------------------------------*}
    CR          =       Chr($0D);           {*Commonly Used ASCII constants *}
    LF          =       Chr($0A);           {*                              *}
    ESC         =       Chr($1B);           {*                              *}
    CRLF        =       CR+LF;              {*                              *}
    NUL         =       Chr($00);           {*                              *}
                                            {*------------------------------*}
    PROGRAMNAME =       'XSL';
    BUFFER_LENGTH=      16384;

  Var
    xmlSource    :      IXMLDOMDocument;    {*------------------------------*}
    xslStyle     :      IXMLDOMDocument;    {*XML/DOM Objects               *}
    szBuffer     :      String;             {*Output Buffer                 *}
    szStyleFile  :      String;             {*XSL Template File             *}
    sBuffer      :      PChar;              {*Output Buffer Pointer         *}
    hStream      :      TMemoryStream;      {*Memory Stream (std Input Load)*}
    i            :      Integer;            {*------------------------------*}

{*-------------------------------------------------------------------------*}
{* Main Program                                                            *}
{* Console loop to serve as a test bed for the TBot/TAiml components       *}
{*-------------------------------------------------------------------------*}
Begin

    szBuffer     := '';
    szStyleFile  := '';
    i            := 1;
    hStream      := TMemoryStream.Create;

    {*--------------------------------------------*}
    {* Process Arguments                          *}
    {*--------------------------------------------*}
    While ParamCount >= i do begin

      If (UpCaseStr(ParamStr(i)) = '-S') then begin
         inc(i);
         szStyleFile  := ParamStr(i);
      end; {endif}

      If (UpCaseStr(ParamStr(i)) = '-?') or
         (UpCaseStr(ParamStr(i)) = '-H') or
         (UpCaseStr(ParamStr(i)) = 'H') or
         (UpCaseStr(ParamStr(i)) = '/H') or
         (UpCaseStr(ParamStr(i)) = '/?') then begin
         WriteLn;
         WriteLn('XSL Simple Translator Filter, options:');
         WriteLn('      xsl -s XSLLFile {-h} < InFile > OutFile');
         WriteLn('         -s XSL Template');
         WriteLn('         -h This Help');
         WriteLn;
         Halt;
      end; {endif}

      inc(i);
    end; {endwhile}
    {*--------------------------------------------*}
    {*          Argument Verification             *}
    {*--------------------------------------------*}

    If szStyleFile = '' then begin
       WriteLn('XSL(016) Error Invalid/Missing XSL Template File');
       Halt;
    end; {endif}

    If FileExists(szStyleFile) = FALSE then begin
       WriteLn('XSL(016) Error XSL Template File('+szStyleFile+') not found');
       Halt;
    end; {endif}

    {*--------------------------------------------*}
    {*    Initialize COM Objects for MSXML3       *}
    {*--------------------------------------------*}
    CoInitialize(nil);
    xmlSource    := CoDOMDocument.Create;
    xslStyle     := CoDOMDocument.Create;


    {*--------------------------------------------*}
    {*    Read the Input into a Stream            *}
    {*--------------------------------------------*}
    While not EOF(Input) do begin
      ReadLn(szBuffer);
      hStream.Write(szBuffer[1],Length(szBuffer));
    end; {endwhile}

    {*--------------------------------------------*}
    {*    Reset Stream and Load into XML Buffer   *}
    {*--------------------------------------------*}
    hStream.Seek(0,0);
    sBuffer := PChar(hStream.Memory);
    xmlSource.loadXML(sBuffer);

    {*--------------------------------------------*}
    {*    Load Style Sheet                        *}
    {*--------------------------------------------*}
    xslStyle.load(szStyleFile);

    {*--------------------------------------------*}
    {*    Convert                                 *}
    {*--------------------------------------------*}
    szBuffer     := xmlSource.transformNode(xslStyle);

    {*--------------------------------------------*}
    {*    Present and Terminate                   *}
    {*--------------------------------------------*}
    WriteLn(szbuffer);
    hStream.Free;
    Halt;

end. { XSL }
